<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <template>
                <div v-if="subs.length === 0">
                    <AnimationComponent text="There are currently no subcontractors. Create one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="0.8"/>
                </div>
                <ListPage>
                    <q-list separator bordered>
                        <SubContractorItem v-for="s in subs" :key="s.id" :sub="s"/>
                    </q-list>
                </ListPage>
                <q-btn fab color="accent" icon="add" class="fixed-bottom-right q-ma-lg" to="/subcontractor/create">
                    <q-tooltip anchor="center left" self="center right">
                        Create a new subcontractor
                    </q-tooltip>
                </q-btn>

            </template>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import WorkerItem from "components/Entities/List/WorkerItem.vue";
import {SubContractorPrincipalResponse} from "src/classLibrary/APIModels/core/subContractorPrincipalResponse";
import SubContractorItem from "components/Entities/List/SubContractorItem.vue";
import ListPage from "components/Core/ListPage.vue";

@Component({
    components: {ListPage, SubContractorItem, WorkerItem, AnimationComponent, DocumentWrapper}
})
export default class SubContractors extends Vue {
    layoutTabs = [];

    subs: SubContractorPrincipalResponse[] = [];


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<SubContractorPrincipalResponse[]>(`SubContractor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.subs = o;
            }
        })

    }

    async created() {
        await this.loadFloors();
    }
}
</script>
